package com.plannaplan.configutils;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Iterator;

import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import com.plannaplan.models.FileData;

/**
 * FileReader is used for reading xls file from input stream.
 */
public class FileReader {

    private InputStream fileInputStream;

    /**
     * @param fileInputStream stream of stadarized file contains courses and gropups
     *                        to import. File needs to be .xlsx file that has
     *                        fields: zaj_cyk_id, typ, sym, nazwa, gr_nr, Mc, dzien,
     *                        godz_od, sala, tytul, nazwisko, imie. Order doesn't
     *                        have impact on import. Any change name of given field
     *                        can be performed in FileToDatabaseMigrator class
     */
    public FileReader(InputStream fileInputStream) {
        this.fileInputStream = fileInputStream;
    }

    /**
     * read data rom file
     * 
     * @return instance of class FileData
     */
    public FileData read() {

        FileData result = null;

        try {
            InputStream fis = this.fileInputStream;
            XSSFWorkbook workbook = new XSSFWorkbook(fis);
            XSSFSheet sheet = workbook.getSheetAt(0);

            Iterator<Row> rowIt = sheet.iterator();

            Row row = rowIt.next();
            Iterator<Cell> cellIt = row.cellIterator();

            HashMap<String, Integer> keys = new HashMap<>();
            int index = 0;
            while (cellIt.hasNext()) {
                Cell c = cellIt.next();
                keys.put(c.toString(), index);
                index += 1;
            }

            rowIt.remove();
            result = new FileData(keys, rowIt);
            workbook.close();
            fis.close();

        } catch (IOException e) {
            e.printStackTrace();
        }

        return result;
    }

}
