package com.plannaplan.security.cas;

/**
 * Model to keep data from Cas response. It's important to remember that wee
 * need to register our domain name in CAS in order to get this data. Otherwise
 * CAS will retuned what user typed as login.
 */
public class CasUserIdentity {
    private String usosId;
    private String email;

    /**
     * creates new instance
     * 
     * @param usosId usosId retured from CAS
     * @param email  emial returned from CAS
     */
    public CasUserIdentity(String usosId, String email) {
        this.usosId = usosId;
        this.email = email;
    }

    /**
     * @return string with usosid
     */
    public String getUsosId() {
        return usosId;
    }

    /**
     * @return string with email
     */
    public String getEmail() {
        return email;
    }
}